import { QueryObject } from 'ufo';
import type { H3Event } from 'h3';
import type { FetchOptions } from 'ofetch';
import type { GraphqlMiddlewareConfig } from './../../../types';
import { GraphqlMiddlewareOperation } from './../../settings';
export declare function queryParamToVariables(query: QueryObject): any;
/**
 * Get the URL of the GraphQL endpoint.
 */
export declare function getEndpoint(moduleConfig: GraphqlMiddlewareConfig, event: H3Event, operation: GraphqlMiddlewareOperation, operationName: string): string;
/**
 * Get the options for the $fetch request to the GraphQL server.
 */
export declare function getFetchOptions(moduleConfig: GraphqlMiddlewareConfig, event: H3Event, operation: GraphqlMiddlewareOperation, operationName: string): FetchOptions;
/**
 * Assure that the request is valid.
 */
export declare function validateRequest(method?: string, operation?: GraphqlMiddlewareOperation, name?: string, documents?: Record<string, Record<string, string>>): void;
